
;***************************************;***************************************
;
;   Author              :	jeff bachiochi
;   Company             :  	imagine that
;   Web Site		:	www.imaginethatnow.com
;   Filename            :  	Midi.s 
;   Date                :  	12/23/2012
;   File Version        :  	1.0
;
;***************************************;***************************************
;
;	Version 1.0	=	Part 1 Midi column (Midi Monitor)
;					monitors Midi messages on UART1,
;					sends text interpretations out UART2
;
;
;   Additional Notes:                         
;                                        
;                                             
	.equ	InvertUART1,	0			; 0=normal, 1=invert
;	31250 baud = BRG=128(@8MHz,BRGH=1)
	.equ	InvertUART2,	1			; 0=normal, 1=inver
;	115200 baud = BRG=8(@8MHz,BRGH=1)
;
;
;
;	Revision 4 chips have a bug in the TX FIFO so I kluged the routines here
;
;***************************************;***************************************
;
        .equ __24FV16KA302, 1
        .include "p24FV16KA302.inc"
;
;***************************************;***************************************
;
;	Configuration bits:
;
;***************************************;***************************************
;
        config __FOSCSEL, FNOSC_FRCDIV  ; use the Internal Clock as the
                                        ; system clock
                                        
        config __FOSC, OSCIOFNC_OFF  	; no clock out                                      

        config __FWDT, FWDTEN_OFF  & WINDIS_OFF	; Turn off Watchdog Timer

        config __FBORPOR,  BORV_V30 & PWRTEN_ON & MCLRE_ON
                                        ; Set Brown-out Reset voltage and
                                        ; and set Power-up Timer to 16msecs
                                            
        config __FGS, GSS0_OFF        	; Set Code Protection Off for the 
                                     	       ;General Segment
		config __FICD,	ICS_PGx3		; Use 
;
;***************************************;***************************************
;
;	Program Specific Constants (literals used in code)
;
;***************************************;***************************************
;
;	PORTA
;	.equ	I0,	0
;	.equ	I1,	1
;	.equ	I2,	2
;	.equ	I3,	3
;	.equ	I4,	4
;	.equ	I5,	5
;	.equ	I6,	6
;	.equ	I7,	7
;
;	PORTB
	.equ	TX2,	0
	.equ	RX2,	1
	.equ	RX1,	2
;	.equ	B3,	3
;	.equ	B4,	4
;	.equ	PGED3,	5
;	.equ	PDGC3,	6
	.equ	TX1,	7
;	.equ	I8,	8
;	.equ	I9,	9
;	.equ	I10,	10
;	.equ	I11,	11
;	.equ	I12,	12
;	.equ	I13,	13
;	.equ	I14,	14
;	.equ	I15,	15
;
;	Flags 
	.equ	U1RXEmpty,	0				; 1=U1RXBuffer is empty
	.equ	U2RXEmpty,	0				; 1=U2RXBuffer is empty
	.equ	U1RXCharacterReady,	2		; 1=Character retireved from U1RXBuffer
	.equ	U2RXCharacterReady,	3		; 1=Character retireved from U2RXBuffer
	.equ	Request,	4				; 1=Good User Request
	.equ	ActiveSenseMessage,	5		; 1=SendActiveSenseMessage
	.equ	MidiClockMessage,	6		; 1=SendMidiClockMessage		
;
    .equ UARTBuffer_Length, 64  		; Buffer Size
;
	.equ	C1,	10
	.equ	C2,	10
	.equ	C3,	10 
	.equ	C4,	10
	.equ	C5,	10 
	.equ	C6,	10
	.equ	C7,	10
	.equ	C8,	10
;
	.equ	N1,	51
	.equ	N2,	52
	.equ	N3,	53 
	.equ	N4,	54
	.equ	N5,	55 
	.equ	N6,	56
	.equ	N7,	57
	.equ	N8,	58	
;
	.equ	V1,	14
	.equ	V2,	14
	.equ	V3,	14 
	.equ	V4,	14
	.equ	V5,	14 
	.equ	V6,	14
	.equ	V7,	14
	.equ	V8,	14
	
;

;***************************************;***************************************
;
;	Global Declarations:
;
;***************************************;***************************************
;
        .global	_wreg_init       		; Provide global scope to _wreg_init 
                                 		; routine. In order to call this routine
                                 		;  from a C file, place "wreg_init" in 
                                 		; an "extern" declarationin the C file.

        .global __reset          		; The label for the first line of code. 

        .global __T1Interrupt    		; Declare Timer 1 ISR name global
        .global __U1TXInterrupt    		; Declare UART1 TX ISR name global
        .global __U1RXInterrupt    		; Declare UART1 RX ISR name global  
        .global __U2TXInterrupt    		; Declare UART2 TX ISR name global
        .global __U2RXInterrupt    		; Declare UART2 RX ISR name global 
        .global __T2Interrupt    		; Declare Timer2 ISR name global  
        .global __T4Interrupt    		; Declare Timer4 ISR name global                                     
;
;***************************************;***************************************
;
;	Constants stored in Program space
;
;***************************************;***************************************
;
        .section .myconstbuffer, code
        .palign 2                		; Align next word stored in Program 
                                 		; space to anaddress that is a multiple
                                 		; of 2
ps_coeff:
        .hword   0x0002, 0x0003, 0x0005, 0x000A
;
;***************************************;***************************************
;
;	Uninitialized variables in Near data memory (Lower 8Kb of RAM)
;
;***************************************;***************************************
;
        .section 	.nbss, bss, near
U1TXBuffer_Head: 	.space 	2   		; U1TXBuffer Pointer (in) 
U1TXBuffer_Tail: 	.space 	2   		; U1TXBuffer Pointer (out)
U1RXBuffer_Head: 	.space 	2   		; U1RXBuffer Pointer (in) 
U1RXBuffer_Tail: 	.space 	2   		; U1RXBuffer Pointer (out)
U2TXBuffer_Head: 	.space 	2   		; U2TXBuffer Pointer (in) 
U2TXBuffer_Tail: 	.space 	2   		; U2TXBuffer Pointer (out)
U2RXBuffer_Head: 	.space 	2   		; U2RXBuffer Pointer (in) 
U2RXBuffer_Tail: 	.space 	2   		; U2RXBuffer Pointer (out)
Flags:				.space	2			; application flags
MidiBeatNumber:		.space	2
TransposeNumber:	.space	2
P1:					.space 	4			; channel, note, voice, notused
P2:					.space 	4
P3:					.space 	4
P4:					.space 	4
P5:					.space 	4
P6:					.space 	4
P7:					.space 	4
P8:					.space 	4
;
U1TXCharacter:	.space	1
U1RXCharacter:	.space	1
U2TXCharacter:	.space	1
U2RXCharacter:	.space	1
MessageNumber:	.space	1
MessageDataCount:	.space	1
NoteNumber:		.space	1
VelocityNumber:	.space	1
ChannelNumber:	.space	1
PressureNumber:	.space	1
ControllerNumber:	.space	1
ValueNumber:	.space	1
ProgramNumber:	.space	1
SongNumber:		.space	1
TimeCodeNumber:	.space	1
TempW:			.space	1
MyPad:			.space	1
MyChannel:		.space	1
MyVoice:		.space	1
MyNote:			.space	1
MyRequest:		.space	1
MyValue:		.space	1
MyBeats:		.space	1
;
U1TXBuffer:			.space	UARTBuffer_Length	; U1TXBuffer 
U1RXBuffer:			.space	UARTBuffer_Length	; U1RXBuffer
U2TXBuffer:			.space	UARTBuffer_Length	; U2TXBuffer 
U2RXBuffer:			.space	UARTBuffer_Length	; U2RXBuffer
SystemCommonBuffer:	.space	UARTBuffer_Length	; Message Buffer
;
;***************************************;***************************************
;
;	Code Section in Program Memory
;
;***************************************;***************************************
;
.text                             		; Start of Code section
__reset:
        mov 	#__SP_init,	W15       	; Initalize the Stack Pointer
        mov 	#__SPLIM_init,	W0     	; Init the Stack Pointer Limit Register
        mov 	W0, SPLIM
        nop                       		; Add NOP to follow SPLIM initialization
;        
        call	_wreg_init           	; Call _wreg_init subroutine
;
init_CLKDIV:
		mov		#0x3000,	W0			; 1:1 (8MHz clk)
		mov		W0,	CLKDIV
		
init_PORTA:
 		mov		#0x0000,	W0			; 1=analog, 0=digital
 										; 15:8=0, 7:0=0 		
 		mov		W0,	ANSA       			; analog/digital
; 		
 		mov		#0x0000,	W0			; 1=open drain, 0=digital
 		 								; 15:8=0, 7:0=0 
 		mov		W0,	ODCA       			; open drain/digital
; 		
 		mov		#0xFFFF,	W0			; 1=input, 0=output
 										; 15:8=FF, 7:0=FF 
 		mov		W0,	TRISA       		; input/output
; 		 		 
 		mov		#0x0000,	W0			; 1=high, 0=low
 										; 15:8=0, 7:0=0 		
 		mov		W0,	LATA       			; pin state
;
init_PORTB:
 		mov		#0x0000,	W0			; 1=analog, 0=digital
 										; 15:8=0, TX1=0, 6:3=0, RX1=0, RX2=0, TX2=0 		
 		mov		W0,	ANSB       			; analog/digital
; 		
 		mov		#0x0000,	W0			; 1=open drain, 0=digital
 										; 15:8=0, TX1=0, 6:3=0, RX1=0, RX2=0, TX2=0 		
 		mov		W0,	ODCB       			; open drain/digital
; 		
 		mov		#0xFFF6,	W0			; 1=input, 0=output
 										; 15:8=0, TX1=0, 6:3=0, RX1=1, RX2=1, TX2=0
 		mov		W0,	TRISB       		; input/output 		 
; 		
 		mov		#0x0000,	W0			; 1=high, 0=low
 										; 15:8=0, TX1=0, 6:3=0, RX1=0, RX2=0, TX2=0
;
 	.if InvertUART1==1
 		bclr	W0,	#TX1
 	.endif
; 	
 	.if InvertUART2==1
 		bclr	W0,	#TX2
 	.endif 
; 		 		
 		mov		W0,	LATB       			; pin state 
;
init_Varaibles:
		mov		#U1TXBuffer,	W0
		mov		W0,	U1TXBuffer_Head
		mov		W0,	U1TXBuffer_Tail	
		mov		#U1RXBuffer,	W0
		mov		W0,	U1RXBuffer_Head
		mov		W0,	U1RXBuffer_Tail	
		mov		#U2TXBuffer,	W0
		mov		W0,	U2TXBuffer_Head
		mov		W0,	U2TXBuffer_Tail	
		mov		#U2RXBuffer,	W0
		mov		W0,	U2RXBuffer_Head
		mov		W0,	U2RXBuffer_Tail	
;
		mov		#P1,	W1
		mov.b	#C1,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N1,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V1,	W0			
		mov.b	W0,	[W1++]
;
		mov		#P2,	W1
		mov.b	#C2,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N2,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V2,	W0			
		mov.b	W0,	[W1++]
;
		mov		#P3,	W1
		mov.b	#C3,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N3,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V3,	W0			
		mov.b	W0,	[W1++]	
;
		mov		#P4,	W1
		mov.b	#C4,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N4,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V4,	W0			
		mov.b	W0,	[W1++]
;
		mov		#P5,	W1
		mov.b	#C5,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N5,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V5,	W0			
		mov.b	W0,	[W1++]
;
		mov		#P6,	W1
		mov.b	#C6,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N6,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V6,	W0			
		mov.b	W0,	[W1++]
;
		mov		#P7,	W1
		mov.b	#C7,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N7,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V7,	W0			
		mov.b	W0,	[W1++]
;
		mov		#P8,	W1
		mov.b	#C8,	W0			
		mov.b	W0,	[W1++]
		mov.b	#N8,	W0			
		mov.b	W0,	[W1++]
		mov.b	#V8,	W0			
		mov.b	W0,	[W1++]												
;
		mov		#60,	W0				; initialize BPM to 60
		mov.b	WREG,	MyBeats
		mov		W0,		W2
		mov		#39360,	W0
		repeat	#17
		div.uw	W0,		W2
		mov		W0,		PR4
;		
init_UART1:
 		mov		#0x8008,	W0			; UARTEN=1, x, USIDL=0, IREN=0,
										; RTSMD=0, x, UEN1=0, UEN0=0,
										; WAKE=0, LPBACK=0, ABAUD=0, RXINV=0,
										; BRGH=1, PDSEL1=0, PDSEL0=0, STSEL=0
;
 	.if InvertUART1==1
 		bset	W0,	#RXINV
 	.endif
; 	
 		mov		W0,	U1MODE      			; U1 Status	
;
 		mov		#0x8510,	W0			; UTXISEL1=1, UTXINV=0, UTXISEL0=0, x,
 										; UTXBRK=0, UTXEN=1, UTXBF=0, TRMT=1,
										; URXISEL1:=00, ADDEN=0, RIDLE=1,
										; PERR=0, FERR=0, OERR=0, URXDA=0
;
 	.if InvertUART1==1
 		bset	W0,	#UTXINV
 	.endif
; 	
 		mov		W0,	U1STA      			; U1 Status				  
;
		mov 	#32,	W0				; @8MHz 32=31250 baud
		mov		W0,	U1BRG
;
		bclr	IFS0,	#U1RXIF			; clear any interrupt
		bset	IEC0,	#U1RXIE			; enable U1RX interrupts		
;						   
init_UART2:
 		mov		#0x8008,	W0			; UARTEN=1, x, USIDL=0, IREN=0,
										; RTSMD=0, x, UEN1=0, UEN0=0,
										; WAKE=0, LPBACK=0, ABAUD=0, RXINV=0,
										; BRGH=1, PDSEL1=0, PDSEL0=0, STSEL=0
;
 	.if InvertUART2==1
 		bset	W0,	#RXINV
 	.endif
; 	
 		mov		W0,	U2MODE      			; U1 Status	
;
 		mov		#0x0510,	W0			; UTXISEL1=0, UTXINV=0, UTXISEL0=0, x,
 										; UTXBRK=0, UTXEN=1, UTXBF=0, TRMT=1,
										; URXISEL1:=00, ADDEN=0, RIDLE=1,
										; PERR=0, FERR=0, OERR=0, URXDA=0
;
 	.if InvertUART2==1
 		bset	W0,	#UTXINV
 	.endif
; 	
 		mov		W0,	U2STA      			; U2 Status				  
;
		mov 	#8,	W0					; @8MHz 16=115000 baud
		mov		W0,	U2BRG
;
		bclr	IFS1,	#U2RXIF			; clear any interrupt
		bset	IEC1,	#U2RXIE			; enable U1RX interrupts		
;
init_Timer2:
		mov		#0x8030,	W0			; TON=1, x=0, TSIDL=0, x, x, x, x, x,
										; x, TGATE=0, TCKPS1:0=11, x, T32=0, TCS=0, x
		mov		W0,		T2CON			; tick=4MHz/256=64uS
;
		mov		#0x124F,	W0	
		mov		W0,		PR2				; 64*0x124F=299mS
;
		bclr	IFS0,	#T2IF			; clear any interrupt
		bset	IEC0,	#T2IE			; enable T2 interrupts		
;
init_Timer4:
		mov		#0x8030,	W0			; TON=1, x=0, TSIDL=0, x, x, x, x, x,
										; x, TGATE=0, TCKPS1:0=11, x, T32=0, TCS=0, x
		mov		W0,		T4CON			; tick=4MHz/256=64uS
;
		bclr	IFS1,	#T4IF			; clear any interrupt
		bset	IEC1,	#T4IE			; enable T2 interrupts					
		
init_SignOn:
		mov		#tblpage(SignOn1), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(SignOn1), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;		
		mov		#tblpage(SignOn2), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(SignOn2), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;		
		mov		#tblpage(SignOn3), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(SignOn3), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF												     
;
;***************************************;***************************************
;
;	Main Code Section 
;
;***************************************;***************************************
;
main:
;***************************************
main_chkU1RX:
		call	U1RXBuffer_Remove
;
		btss	Flags,	#U1RXCharacterReady	; skip next if character available
		goto	main_chkU1RX_Exit
;
		bclr	Flags,	#U1RXCharacterReady
		mov.b	U1RXCharacter,	WREG
		call	MidiData
;		
main_chkU1RX_Exit:			
;***************************************
main_chkU2RX:		
		call	U2RXBuffer_Remove
;
		btss	Flags,	#U2RXCharacterReady	; skip next if character available
		goto	main_chkU2RX_Exit
;
		bclr	Flags,	#U2RXCharacterReady
		mov.b	U2RXCharacter,	WREG
		call	UserRequest
;		
main_chkU2RX_Exit:					
;***************************************
main_chk4PendingMessage:
		btss	Flags,	#MidiClockMessage	; skip next if character available
		goto	main_chk4PendingMessage_Cont
;
		bclr	Flags,	#MidiClockMessage
		mov.b	#0xF8,	W0
		call	SendMidiCharacter
;
main_chk4PendingMessage_Cont:		
		btss	Flags,	#ActiveSenseMessage	; skip next if character available
		goto	main_chk4PendingMessage_Exit
;
		bclr	Flags,	#ActiveSenseMessage
		mov.b	#0xFE,	W0
		call	SendMidiCharacter
;		
main_chk4PendingMessage_Exit:					
;***************************************
main_Exit:
        goto     main              		; last line of executed code
;
;***************************************;***************************************
;
; 	Get Midi Data and do something
;
;***************************************;***************************************
;
MidiData:
		btss	W0,		#7				; skip next if not a status byte
		goto	MidiData_NonStatus
;
MidiData_Status:
		btss	W0,		#6
		goto	MidiData_Status_10xx
;
MidiData_Status_11xx:
		btss	W0,		#5
		goto	MidiData_Status_110x
;
MidiData_Status_111x:
		btss	W0,		#4
		goto	MidiData_Status_1110
;
;***************************************
;
MidiData_Status_1111:					; System
		call	SystemMessage
;
		goto	MidiData_Exit
;
;***************************************
;
MidiData_Status_1110:					; Pitch Wheel
		mov.b	WREG,	MessageNumber
		mov.b	WREG,	ChannelNumber
		mov.b	#0xF0,	W0
		and.b	MessageNumber
		mov.b	#0x0F,W0
		and.b	ChannelNumber				
		mov		#2,		W0
		mov.b	WREG,	MessageDataCount
		goto	MidiData_Exit
;
;***************************************
;
MidiData_Status_110x:
		btss	W0,		#4
		goto	MidiData_Status_1100
;
;***************************************
;
MidiData_Status_1101:					; Channel Pressure
		mov.b	WREG,	MessageNumber
		mov.b	WREG,	ChannelNumber
		mov.b	#0xF0,	W0
		and.b	MessageNumber
		mov.b	#0x0F,	W0
		and.b	ChannelNumber				
		mov		#1,		W0
		mov.b	WREG,	MessageDataCount
		goto	MidiData_Exit
;
;***************************************
;
MidiData_Status_1100:					; Program Patch
		mov.b	WREG,	MessageNumber
		mov.b	WREG,	ChannelNumber
		mov.b	#0xF0,	W0
		and.b	MessageNumber
		mov.b	#0x0F,	W0
		and.b	ChannelNumber				
		mov		#1,		W0
		mov.b	WREG,	MessageDataCount
		goto	MidiData_Exit
;
;***************************************
;
MidiData_Status_10xx:
		btss	W0,		#5
		goto	MidiData_Status_100x
;
MidiData_Status_101x:
		btss	W0,		#4
		goto	MidiData_Status_1010
;
;***************************************
;
MidiData_Status_1011:					; Control Change
		mov.b	WREG,	MessageNumber
		mov.b	WREG,	ChannelNumber
		mov.b	#0xF0,	W0
		and.b	MessageNumber
		mov.b	#0x0F,	W0
		and.b	ChannelNumber				
		mov		#2,		W0
		mov.b	WREG,	MessageDataCount
		goto	MidiData_Exit
;
;***************************************
;
MidiData_Status_1010:					; After Touch
		mov.b	WREG,	MessageNumber
		mov.b	WREG,	ChannelNumber
		mov.b	#0xF0,	W0
		and.b	MessageNumber
		mov.b	#0x0F,	W0
		and.b	ChannelNumber				
		mov		#2,		W0
		mov.b	WREG,	MessageDataCount
		goto	MidiData_Exit
;
;***************************************
;
MidiData_Status_100x:
		btss	W0,		#4
		goto	MidiData_Status_1000
;
;***************************************
;
MidiData_Status_1001:					; Note On
		mov.b	WREG,	MessageNumber
		mov.b	WREG,	ChannelNumber
		mov.b	#0xF0,	W0
		and.b	MessageNumber
		mov.b	#0x0F,	W0
		and.b	ChannelNumber				
		mov		#2,		W0
		mov.b	WREG,	MessageDataCount
		goto	MidiData_Exit
;
;***************************************
;
MidiData_Status_1000:					; Note Off
		mov.b	WREG,	MessageNumber
		mov.b	WREG,	ChannelNumber
		mov.b	#0xF0,	W0
		and.b	MessageNumber
		mov.b	#0x0F,	W0
		and.b	ChannelNumber		
		mov		#2,		W0
		mov.b	WREG,	MessageDataCount
;
		goto	MidiData_Exit		
;
;***************************************
;
MidiData_NonStatus:
		mov.b	WREG,	TempW
		mov.b	#0,	W2
		mov.b	MessageDataCount,	WREG
		mov		W0,	W3
		cpsne.b	W2,	W3
		goto	MidiData_Exit	
;
		mov.b	#1,	W2	
		cpseq.b	W2,	W3
		goto	MidiData_Cont
;
MidiData_NonStatus_1:
		mov		#0x80,	W2
		mov		MessageNumber,	W3
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_Velocity8
;		
		mov		#0x90,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_Velocity9
;		
		mov		#0xA0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_PressureA
;		
		mov		#0xB0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_Value
;		
		mov		#0xC0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_Program
;		
		mov		#0xD0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_PressureD
;		
		mov		#0xE0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_Transpose
;		
		mov		#0xF1,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_TimeCode
;		
		mov		#0xF2,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_MidiBeat		
;		
		mov		#0xF3,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_1_SongNumber
;
		goto	MidiData_Exit		
;
MidiData_NonStatus_1_SongNumber:
		mov.b	TempW,	WREG
		inc.b	W0,		W0
		mov.b	WREG,	SongNumber
		clr.b	MessageDataCount
		call	OutputMessageF3		
		goto	MidiData_Exit
;
MidiData_NonStatus_1_MidiBeat:
		mov.b	TempW,	WREG
		mov		MidiBeatNumber,	W1
		and.b	W0,	W1,	W1
		mov		W1,	MidiBeatNumber
		clr.b	MessageDataCount
		call	OutputMessageF2		
		goto	MidiData_Exit
;
MidiData_NonStatus_1_TimeCode:
		mov.b	TempW,	WREG
		mov.b	WREG,	TimeCodeNumber
		clr.b	MessageDataCount
		call	OutputMessageF1				
		goto	MidiData_Exit
;
MidiData_NonStatus_1_Transpose:
		mov.b	TempW,	WREG
		mov		TransposeNumber,	W1
		and.b	W0,	W1,	W1
		mov		W1,	TransposeNumber
		mov.b	#2,		W0
		mov.b	WREG,	MessageDataCount
		call	OutputMessageE				
		goto	MidiData_Exit
;
MidiData_NonStatus_1_PressureD:
		mov.b	TempW,	WREG
		mov.b	WREG,	PressureNumber
		mov.b	#1,		W0
		mov.b	WREG,	MessageDataCount
		call	OutputMessageD				
		goto	MidiData_Exit		
;
MidiData_NonStatus_1_PressureA:
		mov.b	TempW,	WREG
		mov.b	WREG,	PressureNumber
		mov.b	#2,		W0
		mov.b	WREG,	MessageDataCount
		call	OutputMessageA				
		goto	MidiData_Exit
;
MidiData_NonStatus_1_Program:
		mov.b	TempW,	WREG
		mov.b	WREG,	ProgramNumber
		mov.b	#1,		W0
		mov.b	WREG,	MessageDataCount
		call	OutputMessageC				
		goto	MidiData_Exit
;
MidiData_NonStatus_1_Value:
		mov.b	TempW,	WREG
		mov.b	WREG,	ValueNumber
		mov.b	#2,		W0
		mov.b	WREG,	MessageDataCount
		call	OutputMessageB
		goto	MidiData_Exit
;
MidiData_NonStatus_1_Velocity9:
		mov.b	TempW,	WREG
		mov.b	WREG,	VelocityNumber
		mov.b	#2,		W0
		mov.b	WREG,	MessageDataCount
		call	OutputMessage9		
		goto	MidiData_Exit		
;
MidiData_NonStatus_1_Velocity8:
		mov.b	TempW,	WREG
		mov.b	WREG,	VelocityNumber
		mov.b	#2,		W0
		mov.b	WREG,	MessageDataCount
		call	OutputMessage8		
		goto	MidiData_Exit																													
;
MidiData_Cont:
		mov.b	#2,	W2	
		cpseq.b	W2,	W3
		goto	MidiData_NonStatus_3
;
MidiData_NonStatus_2:
		mov		#0x80,	W2
		mov		MessageNumber,	W3
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_Note
;		
		mov		#0x90,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_Note
;		
		mov		#0xA0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_Note
;		
		mov		#0xB0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_Controller
;		
		mov		#0xC0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_Program
;		
		mov		#0xD0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_Pressure				
;		
		mov		#0xE0,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_Transpose
;		
		mov		#0xF2,	W2
		cp.b	W2,	W3
		bra		z,	MidiData_NonStatus_2_MidiBeat				
;		
		goto	MidiData_Exit
;
MidiData_NonStatus_2_MidiBeat:
		mov.b	TempW,	WREG
		swap.b	W0
		lsr		W0,	W0
		mov		W0,	MidiBeatNumber
		dec.b	MessageDataCount
		goto	MidiData_Exit				
;
MidiData_NonStatus_2_Transpose:
		mov.b	TempW,	WREG
		swap.b	W0
		lsr		W0,	W0
		mov		W0,	TransposeNumber
		dec.b	MessageDataCount		
		goto	MidiData_Exit
;		
MidiData_NonStatus_2_Pressure:
		mov.b	TempW,	WREG
		mov.b	WREG,	PressureNumber
		dec.b	MessageDataCount		
		goto	MidiData_Exit
;		
MidiData_NonStatus_2_Program:
		mov.b	TempW,	WREG
		mov.b	WREG,	ProgramNumber
		dec.b	MessageDataCount		
		goto	MidiData_Exit				
;		
MidiData_NonStatus_2_Controller:
		mov.b	TempW,	WREG
		mov.b	WREG,	ControllerNumber
		dec.b	MessageDataCount		
		goto	MidiData_Exit
;				
MidiData_NonStatus_2_Note:
		mov.b	TempW,	WREG
		mov.b	WREG,	NoteNumber
		dec.b	MessageDataCount				
		goto	MidiData_Exit
;
MidiData_NonStatus_3:
		mov.b	TempW,	WREG
		call	SendValue
;
		mov		#' ',	W0
		call	SendCharacter
;				
		goto	MidiData_Cont
;
MidiData_Exit:				
		return  
;
;***************************************;***************************************
;
; 	Got System Message
;
;***************************************;***************************************
;
SystemMessage:
		btss	W0,		#3				; skip next if not a status byte
		goto	SystemMessage_11110xxx
		
;
SystemMessage_11111xxx:
		btss	W0,		#2
		goto	SystemMessage_111110xx
;
SystemMessage_111111xx:
		btss	W0,		#1
		goto	SystemMessage_1111110x
;
SystemMessage_1111111x:
		btss	W0,		#0
		goto	SystemMessage_11111110
;
;***************************************
;
SystemMessage_11111111:					; System Reset
		mov		#0xFF,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageFF), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageFF), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11111110:					; System Active Sense
		mov		#0xFE,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageFE), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageFE), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_1111110x:
		btss	W0,		#0
		goto	SystemMessage_11111100
;
;***************************************
;
SystemMessage_11111101:					; System (none)
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11111100:					; System Midi Stop
		mov		#0xFC,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageFC), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageFC), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_111110xx:
		btss	W0,		#1
		goto	SystemMessage_1111100x
;
SystemMessage_1111101x:
		btss	W0,		#0
		goto	SystemMessage_11111010
;
;***************************************
;
SystemMessage_11111011:					; System Midi Continue
		mov		#0xFB,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageFB), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageFB), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11111010:					; System Midi Start
		mov		#0xFA,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageFA), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageFA), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_1111100x:
		btss	W0,		#0
		goto	SystemMessage_11111000
;
;***************************************
;
SystemMessage_11111001:					; System Tick
		mov		#0xF9,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageF9), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF9), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11111000:					; System Midi Clock
		mov		#0xF8,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageF8), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF8), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit		
;
;***************************************
;
SystemMessage_11110xxx:
		btss	W0,		#2
		goto	SystemMessage_111100xx
;
SystemMessage_111101xx:
		btss	W0,		#1
		goto	SystemMessage_1111010x
;
SystemMessage_1111011x:
		btss	W0,		#0
		goto	SystemMessage_11110110
;
;***************************************
;
SystemMessage_11110111:					; System  End Of SysEx
		mov		#0xF7,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageF7), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF7), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11110110:					; System Tune Request
		mov		#0xF6,	W0
		mov.b	WREG,		MessageNumber
		mov		#0,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageF6), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF6), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_1111010x:
		btss	W0,		#0
		goto	SystemMessage_11110100
;
;***************************************
;
SystemMessage_11110101:					; System (none)
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11110100:					; System (none)
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_111100xx:
		btss	W0,		#1
		goto	SystemMessage_1111000x
;
SystemMessage_1111001x:
		btss	W0,		#0
		goto	SystemMessage_11110010
;
;***************************************
;
SystemMessage_11110011:					; System Song Select
		mov		#0xF3,	W0
		mov.b	WREG,		MessageNumber
		mov		#1,		W0
		mov.b	WREG,	MessageDataCount
		mov		#tblpage(MessageF3), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF3), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;						
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11110010:					; System Song Pointer
		mov		#0xF2,	W0
		mov.b	WREG,		MessageNumber
		mov		#2,		W0
		mov.b	WREG,		MessageDataCount
		mov		#tblpage(MessageF2), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF2), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_1111000x:
		btss	W0,		#0
		goto	SystemMessage_11110000
;
;***************************************
;
SystemMessage_11110001:					; System MTC Quarter Frame Message
		mov		#0xF1,	W0
		mov.b	WREG,		MessageNumber
		mov		#1,		W0
		mov.b	WREG,		MessageDataCount
		mov		#tblpage(MessageF1), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF1), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;
		goto	SystemMessage_Exit
;
;***************************************
;
SystemMessage_11110000:					; System Start Of SysEx
		mov		#0xF0,	W0
		mov.b	WREG,		MessageNumber
		mov		#3,		W0
		mov.b	WREG,		MessageDataCount
		mov		#tblpage(MessageF0), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF0), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;
		goto	SystemMessage_Exit		
;
SystemMessage_Exit:				
		return 
;
;***************************************;***************************************
;
; 	Get Use Request from U2RX Buffer
;
;
;	Px<cr>	=	set pad number 1-8
;	Cx<cr>	=	set channel number 1-16
;	Vx<cr>	=	set voice (instrumemt) number 0-127
;	Nx<cr>	=	set pad note number 0-127
;	Sx<cr>	=	save pad configuration
;	Tx<cr>	=	trigger pad number 1-8
;	Bx<cr>	=	beats number 30-180
;
;***************************************;***************************************
;
UserRequest:
		mov.b	#'a',	W1
		cpslt	W0,		W1
		bclr	W0,		#5				; force to upper case
		mov.b	#'P',	W1
		cpsne.b	W0,		W1
		goto	UserRequest_SaveRequest
;
		mov.b	#'C',	W1
		cpsne.b	W0,		W1
		goto	UserRequest_SaveRequest
;
		mov.b	#'V',	W1
		cpsne.b	W0,		W1
		goto	UserRequest_SaveRequest
;
		mov.b	#'N',	W1
		cpsne.b	W0,		W1
		goto	UserRequest_SaveRequest
;
		mov.b	#'S',	W1
		cpsne.b	W0,		W1
		goto	UserRequest_SaveRequest
;
		mov.b	#'B',	W1
		cpsne.b	W0,		W1
		goto	UserRequest_SaveRequest		
;
		mov.b	#'T',	W1
		cpsne.b	W0,		W1
		goto	UserRequest_SaveRequest
;
		mov.b	#0x0D,	W1
		cpsne.b	W0,		W1
		goto	UserRequest_CR		
;
		mov.b	#'/',	W1
		cpsgt.b	W0,		W1
		goto	UserRequest_Exit
;		
		mov.b	#':',		W1
		cpslt.b	W0,		W1		
		goto	UserRequest_Exit
;
UserRequest_Number:
		mov.b	WREG,		TempW
		clr		W0		
		mov.b	MyValue,	WREG
		mov		#10,	W1
		mul.uu 	W0,		W1,		W2
		mov.b	TempW,	WREG
		and.b	#0xF,	W0
		add.b	W0,		W2,		W0
		mov.b	WREG,	MyValue
		bset	Flags,	#Request
		goto	UserRequest_Exit
;
UserRequest_SaveRequest:
		mov.b	WREG,	MyRequest
		bclr	Flags,	#Request
		goto	UserRequest_Exit		
;
UserRequest_CR:
		mov.b	MyRequest,	WREG
		mov.b	#'P',	W1
		cpsne.b	W0,	W1
		goto	UserRequest_P
;
		mov.b	MyRequest,	WREG
		mov.b	#'C',	W1
		cpsne.b	W0,	W1
		goto	UserRequest_C
;
		mov.b	MyRequest,	WREG
		mov.b	#'V',	W1
		cpsne.b	W0,	W1
		goto	UserRequest_V
;
		mov.b	MyRequest,	WREG
		mov.b	#'N',	W1
		cpsne.b	W0,	W1
		goto	UserRequest_N
;
		mov.b	MyRequest,	WREG
		mov.b	#'S',	W1
		cpsne.b	W0,	W1
		goto	UserRequest_S
;
		mov.b	MyRequest,	WREG
		mov.b	#'B',	W1
		cpsne.b	W0,	W1
		goto	UserRequest_B
;
		mov.b	MyRequest,	WREG
		mov.b	#'T',	W1
		cpsne.b	W0,	W1
		goto	UserRequest_T		
;
UserRequest_Bad:
		call	OutputEntryError
;		
UserRequest_Cleanup:
		clr.b	MyRequest
		clr.b	MyValue		
		goto	UserRequest_Exit										
;
UserRequest_P:							; Request to set Pad
		mov.b	MyValue,	WREG
		cp0.b	MyValue
		bra		Z,	UserRequest_Bad
		mov.b	#9,	W1
		cpslt	W0,	W1
		goto	UserRequest_Bad
;
UserRequest_PGood:		
		mov.b	WREG,		MyPad
		call	OutputPadSettings
;		
		goto	UserRequest_Cleanup		
;
UserRequest_C:							; Request to set Channel
		mov.b	MyValue,	WREG
		cp0.b	MyValue
		bra		Z,	UserRequest_Bad
		mov.b	#17,	W1
		cpslt	W0,	W1
		goto	UserRequest_Bad
;
UserRequest_CGood:		
		mov.b	WREG,		MyChannel
		call	OutputPadSettings
;		
		goto	UserRequest_Cleanup
;
UserRequest_V:							; Request to set Voice
		mov.b	MyValue,	WREG
		cp0.b	MyValue
		bra		Z,	UserRequest_Bad
		mov.b	#129,	W1
		cpslt	W0,	W1
		goto	UserRequest_Bad
;
UserRequest_VGood:		
		mov.b	WREG,		MyVoice
		call	OutputPadSettings
;		
		goto	UserRequest_Cleanup
;
UserRequest_N:							; Request to set Note
		mov.b	MyValue,	WREG
		cp0.b	MyValue
		bra		Z,	UserRequest_Bad
		mov.b	#129,	W1
		cpslt	W0,	W1
		goto	UserRequest_Bad
;
UserRequest_NGood:		
		mov.b	WREG,		MyNote
		call	OutputPadSettings
;		
		goto	UserRequest_Cleanup
;
UserRequest_S:							; Request to Save settings
;		mov.b	MyValue,	WREG
;		cp0.b	MyValue
;		bra		Z,	UserRequest_Bad
;		mov.b	#9,	W1
;		cpslt	W0,	W1
;		goto	UserRequest_Bad
;
;UserRequest_SGood:
;		mov.b	W0,		MySave
		goto	UserRequest_Cleanup		
;
UserRequest_T:							; Request to trigger
		mov.b	MyValue,	WREG
		cp0.b	MyValue
		bra		Z,	UserRequest_Bad
		mov.b	#9,	W1
		cpslt	W0,	W1
		goto	UserRequest_Bad
;
UserRequest_TGood:
		call	TriggerPad
;		
		mov		#tblpage(Triggering), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Triggering), W1	; Make a pointer to table 
		call	SendMessage
;
		mov.b	MyPad,	WREG
		call	SendValue
;
		call	SendCRLF		
;
		goto	UserRequest_Cleanup	
;
UserRequest_B:							; Request a BPM (tempo)
		clr		W0
		mov.b	MyValue,	WREG
		mov		#30,	W1
		cp.b	W0,	W1
		bra		ltu,	UserRequest_Bad
;		
		mov		#180,	W1
		cp.b	W0,	W1
		bra		gtu,	UserRequest_Bad		
;
UserRequest_BGood:
		mov.b	WREG,	MyBeats
		mov		W0,		W2
		mov		#39360,	W0
		repeat	#17
		div.uw	W0,		W2
		mov		W0,		PR4
;		
		mov		#tblpage(Beats), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Beats), W1	; Make a pointer to table 
		call	SendMessage
;
		mov.b	MyBeats,	WREG
		call	SendValue
;
		call	SendCRLF		
;
		goto	UserRequest_Cleanup	
UserRequest_Exit:
		return		      		     
;
;***************************************;***************************************
;
; 	Add a character to the U1TX Buffer
;
;***************************************;***************************************
;
U1TXBuffer_Add:
		push.d	W0
;
U1TXBuffer_Add_Loop:		
		disi	#9
		mov		U1TXBuffer_Head,	W1
		inc		W1,	W1
		mov		#U1TXBuffer+UARTBuffer_Length,	W0
		cpsne	W0,			W1			; skip next if past the U1TXBuffer
;
		mov		#U1TXBuffer,	W1
;				
		mov		U1TXBuffer_Tail,	W0
		cpseq	W0,			W1			; skip next if there is no room
		goto	U1TXBuffer_Add_Room
;
U1TXBuffer_Add_NoRoom:
		nop
		nop
		nop
		nop
		goto	U1TXBuffer_Add_Loop
;
U1TXBuffer_Add_Room:
		disi	#9
		mov		U1TXBuffer_Head,	W1
		mov.b	U1TXCharacter,	WREG
		mov.b	W0,			[W1++]		
		mov		#U1TXBuffer+UARTBuffer_Length,	W0
		cpseq	W1,			W0			; skip next if past the U1TXBuffer
		goto	U1TXBuffer_Add_Room_NoWrap	
;
U1TXBuffer_Add_Room_Wrap:
		mov		#U1TXBuffer,	W1
;
U1TXBuffer_Add_Room_NoWrap:
		mov		W1,			U1TXBuffer_Head
		bset	IEC0,		#U1TXIE		; Enable U1Transmit Interrupt	
;
U1TXBuffer_Add_Exit:
		pop.d	W0			
		return
;
;***************************************;***************************************
;
; 	Check the U1RX Buffer for characters
;
;***************************************;***************************************
;
U1RXBuffer_Check:
		mov		U1RXBuffer_Head,	W0
		mov		U1RXBuffer_Tail,	W1
		cpseq	W0,	W1					; skip next if buffer is empty
		goto	U1RXBuffer_Check_NotEmpty
;
U1RXBuffer_Check_Empty:
		bset	Flags,	#U1RXEmpty
		goto	U1RXBuffer_Check_Exit
;
U1RXBuffer_Check_NotEmpty:
		bclr	Flags,	#U1RXEmpty
		goto	U1RXBuffer_Check_Exit
;
U1RXBuffer_Check_Exit:
		return
;
;***************************************;***************************************
;
; 	Remove a character from the U1RX Buffer
;
;***************************************;***************************************
;
U1RXBuffer_Remove:
		disi	#20
		call	U1RXBuffer_Check
;
		btsc	Flags,		#U1RXEmpty	; skip next if its not Empty
		goto	U1RXBuffer_Remove_Exit
;
		mov		U1RXBuffer_Tail,	W1
		mov.b	[W1++],		W0
		mov.b	WREG,		U1RXCharacter
		mov		#U1RXBuffer+UARTBuffer_Length,	W0
		cpseq	W0,			W1			; skip next if past the Buffer
		goto	U1RXBuffer_Remove_Room_NoWrap
;
U1RXBuffer_Remove_Room_Wrap:
		mov		#U1RXBuffer,	W1
;
U1RXBuffer_Remove_Room_NoWrap:
		mov		W1,	U1RXBuffer_Tail	
		bset	Flags,	#U1RXCharacterReady					
;
U1RXBuffer_Remove_Exit:
		return
;
;***************************************;***************************************
;
; 	Add a character to the U2TX Buffer
;
;***************************************;***************************************
;
U2TXBuffer_Add:
		push.d	W0
;
U2TXBuffer_Add_Loop:		
		disi	#9
		mov		U2TXBuffer_Head,	W1
		inc		W1,	W1
		mov		#U2TXBuffer+UARTBuffer_Length,	W0
		cpsne	W0,			W1			; skip next if past the U2TXBuffer
;
		mov		#U2TXBuffer,	W1
;				
		mov		U2TXBuffer_Tail,	W0
		cpseq	W0,			W1			; skip next if there is no room
		goto	U2TXBuffer_Add_Room
;
U2TXBuffer_Add_NoRoom:
		nop
		nop
		nop
		nop
		goto	U2TXBuffer_Add_Loop
;
U2TXBuffer_Add_Room:
		disi	#9
		mov		U2TXBuffer_Head,	W1
		mov.b	U2TXCharacter,	WREG
		mov.b	W0,			[W1++]		
		mov		#U2TXBuffer+UARTBuffer_Length,	W0
		cpseq	W1,			W0			; skip next if past the U2TXBuffer
		goto	U2TXBuffer_Add_Room_NoWrap	
;
U2TXBuffer_Add_Room_Wrap:
		mov		#U2TXBuffer,	W1
;
U2TXBuffer_Add_Room_NoWrap:
		mov		W1,			U2TXBuffer_Head
		bset	IEC1,		#U2TXIE		; Enable U2Transmit Interrupt	
;
U2TXBuffer_Add_Exit:
		pop.d	W0			
		return
;
;***************************************;***************************************
;
; 	Check the U2RX Buffer for characters
;
;***************************************;***************************************
;
U2RXBuffer_Check:
		mov		U2RXBuffer_Head,	W0
		mov		U2RXBuffer_Tail,	W1
		cpseq	W0,	W1					; skip next if buffer is empty
		goto	U2RXBuffer_Check_NotEmpty
;
U2RXBuffer_Check_Empty:
		bset	Flags,	#U2RXEmpty
		goto	U2RXBuffer_Check_Exit
;
U2RXBuffer_Check_NotEmpty:
		bclr	Flags,	#U2RXEmpty
		goto	U2RXBuffer_Check_Exit
;
U2RXBuffer_Check_Exit:
		return
;
;***************************************;***************************************
;
; 	Remove a character from the U2RX Buffer
;
;***************************************;***************************************
;
U2RXBuffer_Remove:
		disi	#20
		call	U2RXBuffer_Check
;
		btsc	Flags,		#U2RXEmpty	; skip next if its not Empty
		goto	U1RXBuffer_Remove_Exit
;
		mov		U2RXBuffer_Tail,	W1
		mov.b	[W1++],		W0
		mov.b	WREG,		U2RXCharacter
		mov		#U2RXBuffer+UARTBuffer_Length,	W0
		cpseq	W0,			W1			; skip next if past the Buffer
		goto	U2RXBuffer_Remove_Room_NoWrap
;
U2RXBuffer_Remove_Room_Wrap:
		mov		#U2RXBuffer,	W1
;
U2RXBuffer_Remove_Room_NoWrap:
		mov		W1,	U2RXBuffer_Tail	
		bset	Flags,	#U2RXCharacterReady					
;
U2RXBuffer_Remove_Exit:
		return				
;
;***************************************;***************************************
;
;	Subroutine: Initialization of W registers to 0x0000
;
;***************************************;***************************************
;
_wreg_init:
        clr 	W0
        mov 	W0,	W14
        repeat 	#12
        mov 	W0, [++W14]
        clr 	W14
        return
;
;***************************************;***************************************
;
;	Subroutine: Send Midi Note ON
;
;	Required
;		W0	=	Pad#
;
;	Format	#0x90+channel, note, velocity
;
;***************************************;***************************************
;
TriggerPad:
;
TriggerPad_NoteON:
		clr		W0
		mov.b	MyPad,	WREG			; get the Pad#
		rlnc	W0,		W0				; times 2
		rlnc	W0,		W0				; times 2
		mov		#P1,	W4				; P1 is base address
		add.b	W0,		W4,		W4		; add in offset
		mov.b	[W4++],	W1				; channel value at offset
		dec.b	W1,		W1				; minus 1		
;	
		mov.b	#0x90,	W0				; status for Note ON
		add.b	W1,		W0,		W0		; total status including channel
		call	SendMidiCharacter
;
		mov.b	[W4],	W0				; note value at offset
		dec.b	W0,		W0				; minus 1
		call	SendMidiCharacter
;
		mov.b	#64,	W0				; velocity of 64
		dec.b	W0,		W0				; minus 1		
		call	SendMidiCharacter
;
TriggerPad_NoteOFF:
		clr		W0
		mov.b	MyPad,	WREG			; get the Pad#
		rlnc	W0,		W0				; times 2
		rlnc	W0,		W0				; times 2
		mov		#P1,	W4				; P1 is base address
		add.b	W0,		W4,		W4		; add in offset
		mov.b	[W4++],	W1				; channel value at offset
		dec.b	W1,		W1				; minus 1		
;	
		mov.b	#0x80,	W0				; status for Note ON
		add.b	W1,		W0,		W0		; total status including channel
		call	SendMidiCharacter
;
		mov.b	[W4],	W0				; note value at offset
		dec.b	W0,		W0				; minus 1		
		call	SendMidiCharacter
;
		mov.b	#0,		W0				; velocity of 0
		call	SendMidiCharacter										
;
TriggerPad_Exit:
		clr		TMR2					; reset the Active Sense Timer
		return
;
;***************************************;***************************************
;
;	Subroutine: Output Pad Settings
;
;	Format:	"Pad:w, Channel:x, Note: y, Voice: z" 
;***************************************;***************************************
;        
OutputPadSettings:
		mov		#tblpage(Pad), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Pad), W1	; Make a pointer to table 
		call	SendMessage
;
		mov.b	MyPad,	WREG
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov.b	#' ',	W0
		call	SendCharacter
;
		mov		#tblpage(Channel), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Channel), W1	; Make a pointer to table 
		call	SendMessage
;
		clr		W0
		mov.b	MyPad,	WREG
		dec.b	W0,		W0
		rlnc	W0,		W0
		rlnc	W0,		W0
		mov		#P1,	W4
		add.b	W0,		W4,		W4
		mov.b	[W4++],	W0	
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov.b	#' ',	W0
		call	SendCharacter
;
		mov		#tblpage(Note), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Note), W1	; Make a pointer to table 
		call	SendMessage
;
		mov.b	[W4++],	W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov.b	#' ',	W0
		call	SendCharacter
;
		mov		#tblpage(Voice), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Voice), W1	; Make a pointer to table 
		call	SendMessage
;
		mov.b	[W4],	W0		
		call	SendValue
;
		call	SendCRLF
;				
		return
;
;***************************************;***************************************
;
;	Subroutine: Output Entry Error Message
;
;	Format:	"Pad:w, Channel:x, Note: y, Voice: z" 
;***************************************;***************************************
;        
OutputEntryError:
		mov		#tblpage(EntryError), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(EntryError), W1	; Make a pointer to table 
		call	SendMessage
;
		call	SendCRLF
;
		return				
;
;***************************************;***************************************
;
;	Subroutine: Output Message8
;
;	Format:	"Note Off (Channel:x, Note:y, Velocity:z)" 
;***************************************;***************************************
;
OutputMessage8:
		mov		#tblpage(Message8), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Message8), W1	; Make a pointer to table 
		call	SendMessage
;		
		mov		#tblpage(Channel), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Channel), W1	; Make a pointer to table 
		call	SendMessage
;
		mov.b	ChannelNumber,	WREG
		inc.b	W0,		W0
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Note), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Note), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	NoteNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Velocity), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Velocity), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	VelocityNumber,	WREG
		call	SendValue
;
		mov.b	#')',	W0
		call	SendCharacter
;
		call	SendCRLF
;				
		return 
;
;***************************************;***************************************
;
;	Subroutine: Output Message9
;
;	Format:	"Note On (Channel:x, Note:y, Velocity:z)" 
;***************************************;***************************************
;
OutputMessage9:
		mov		#tblpage(Message9), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Message9), W1	; Make a pointer to table
		call	SendMessage
;
		mov		#tblpage(Channel), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Channel), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ChannelNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Note), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Note), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	NoteNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Velocity), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Velocity), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	VelocityNumber,	WREG
		call	SendValue
;
		mov.b	#')',	W0
		call	SendCharacter
;
		call	SendCRLF
;				
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageA
;
;	Format:	"Channel: x, Note: y, Pressure: z, Aftertouch" 
;***************************************;***************************************
;
OutputMessageA:
		mov		#tblpage(MessageA), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageA), W1	; Make a pointer to table
		call	SendMessage
;
		mov		#tblpage(Channel), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Channel), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ChannelNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Note), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Note), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	NoteNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Pressure), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Pressure), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	PressureNumber,	WREG
		call	SendValue
;
		mov.b	#')',	W0
		call	SendCharacter
;
		call	SendCRLF
;				
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageB
;
;	Format:	"Control Change (Controller:x, Value:y)" 
;***************************************;***************************************
;
OutputMessageB:
		mov		#tblpage(MessageB), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageB), W1	; Make a pointer to table
		call	SendMessage
;
		mov		#tblpage(Controller), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Controller), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ControllerNumber,	WREG
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Value), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Value), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ValueNumber,	WREG
		call	SendValue
;
		mov.b	#')',	W0
		call	SendCharacter
;
		call	SendCRLF
;				
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageC
;
;	Format:	"Program Change (Channel:x, Program:y)" 
;***************************************;***************************************
;
OutputMessageC:
		mov		#tblpage(MessageC), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageC), W1	; Make a pointer to table
		call	SendMessage
;
		mov		#tblpage(Channel), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Channel), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ChannelNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Program), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Program), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ProgramNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#')',	W0
		call	SendCharacter
;
		call	SendCRLF
;				
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageD
;
;	Format:	"Pressure Change (Channel:x, Pressure:y)" 
;***************************************;***************************************
;
OutputMessageD:
		mov		#tblpage(MessageD), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageD), W1	; Make a pointer to table
		call	SendMessage
;
		mov		#tblpage(Channel), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Channel), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ChannelNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Pressure), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Pressure), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	PressureNumber,	WREG
		call	SendValue
;
		mov.b	#')',	W0
		call	SendCharacter
;
		call	SendCRLF
;				
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageE
;
;	Format:	"Pitch Wheel (Channel:x, Transpose:y)" 
;***************************************;***************************************
;
OutputMessageE:
		mov		#tblpage(MessageE), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageE), W1	; Make a pointer to table
		call	SendMessage
;
		mov		#tblpage(Channel), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Channel), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	ChannelNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		mov.b	#',',	W0
		call	SendCharacter
;
		mov		#tblpage(Transpose), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Transpose), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	TransposeNumber,	WREG
		call	SendTranspose
;
		mov.b	#')',	W0
		call	SendCharacter
;
		call	SendCRLF
;				
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageF1
;
;***************************************;***************************************
;
OutputMessageF1:
		mov		#tblpage(MessageF1), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF1), W1	; Make a pointer to table
		call	SendMessage
;
		call	SendCRLF
;		
		mov		#tblpage(TimeCode), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(TimeCode), W1	; Make a pointer to table
		call	SendMessage
;
		mov		TimeCodeNumber,	WREG
		call	SendValue
;
		call	SendCRLF
;		
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageF2
;
;***************************************;***************************************
;
OutputMessageF2:
		mov		#tblpage(MessageF2), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF2), W1	; Make a pointer to table
		call	SendMessage
;
		call	SendCRLF
;		
		mov		#tblpage(MidiBeat), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MidiBeat), W1	; Make a pointer to table
		call	SendMessage
;
		mov		MidiBeatNumber,	WREG
		call	SendValue
;
		call	SendCRLF
;		
		return
;
;***************************************;***************************************
;
;	Subroutine: Output MessageF3
;
;***************************************;***************************************
;
OutputMessageF3:
		mov		#tblpage(MessageF3), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(MessageF3), W1	; Make a pointer to table
		call	SendMessage
;
		call	SendCRLF
;		
		mov		#tblpage(Song), W1
		mov		W1, _TBLPAG 	    	; Set TBLPAG to the page that contains
										; the table array.
		mov		#tbloffset(Song), W1	; Make a pointer to table
		call	SendMessage
;
		mov.b	SongNumber,	WREG
		inc.b	W0,		W0		
		call	SendValue
;
		call	SendCRLF
;		
		return		
;
;***************************************;***************************************
;
;	Send a Message
;
;	Requires
;		W1	=	Message Pointer
;	Changes
;		U2TXCharacterIn
;		W0
;		W1
;	Calls
;		U2TXBuffer_Add (Destroys none)
;
;***************************************;***************************************
;
SendMessage:
;
SendMessage_Loop: 
		tblrdl.b	[W1++],	W0			; Load the first data value
		cp0.b	W0
		bra		Z,	SendMessage_Exit
;
		mov.b	WREG,	U2TXCharacter
		call	U2TXBuffer_Add
;
		goto	SendMessage_Loop	
;		
SendMessage_Exit:
		return
;
;***************************************;***************************************
;
;	Send a Value
;
;	Requires
;		W0	=	Value
;	Changes
;		W0
;		W1
;	Calls
;		SendCharacter (Destroys none)
;
;***************************************;***************************************
;
SendValue:
		push.d	W2
		clr		W2
		mov.b	W0,	W2
		mov		#100,	W3
		repeat 	#17		
		div.uw	W2,	W3
		add		#0x30,	W0
		call	SendCharacter
;
		clr		W2
		mov.b	W1,	W2
		mov		#10,	W3
		repeat 	#17		
		div.uw	W2,	W3
		add		#0x30,	W0
		call	SendCharacter
;
		mov.b	W1,		W0
		add		#0x30,	W0
		call	SendCharacter		
		
		pop.d	W2
		return
;
;***************************************;***************************************
;
;	Send a Transpose Value
;
;***************************************;***************************************
;
SendTranspose:
		return		
;
;***************************************;***************************************
;
;	Send a Character
;
;	Requires
;		U2TXCharacter
;	Calls
;		U2TXBuffer_Add (Destroys none)
;
;***************************************;***************************************
;
SendCharacter:
		mov.b	WREG,	U2TXCharacter
		call	U2TXBuffer_Add
;		
		return
;
;***************************************;***************************************
;
;	Send a CRLF
;
;	Changes
;		W0
;	Calls
;		U2TXBuffer_Add (Destroys none)
;
;***************************************;***************************************
;
SendCRLF:		
		mov.b	#0x0D,	W0
		call	SendCharacter
;						
		mov.b	#0x0A,	W0
		call	SendCharacter
;
		return	
;
;***************************************;***************************************
;
;	Send a character to Midi 
;
;	Requires
;		W0	=	character to send
;	Changes
;		U1TXCharacter
;	Calls
;		U1TXBuffer_Add (Destroys none)
;
;***************************************;***************************************
;
SendMidiCharacter:
		mov.b	WREG,	U1TXCharacter
		call	U1TXBuffer_Add
;		
SendMidiCharacter_Exit:
		return																											       
;
;***************************************;***************************************
;
;	Timer 1 Interrupt Service Routine
;	Example context save/restore in the ISR performed using PUSH.D/POP.D
;	instruction. The instruction pushes two words W4 and W5 on to the stack on
;	entry into ISR and pops the two words back into W4 and W5 on exit from the ISR
;
;***************************************;***************************************
;
__T1Interrupt:
        push.D 	W4                  	;Save context using double-word PUSH

        ;<<insert more user code here>>

        bclr 	IFS0,	#T1IF           ;Clear the Timer1 Interrupt flag Status
                                   		;bit.
        pop.D 	W4                   	;Retrieve context POP-ping from Stack
        retfie                     		;Return from Interrupt Service routine
;
;***************************************;***************************************
;
;	UART1 TX Interrupt Service Routine
;
;***************************************;***************************************
;
__U1TXInterrupt:
        push.D 	W0 						; Save context using double-word PUSH
;        bclr 	IFS0,	#U1TXIF         ; Clear the U1TX Interrupt flag bit.        
;
U1TXInterrupt_Loop:                         	
		mov		U1TXBuffer_Head,	W0
		mov		U1TXBuffer_Tail,	W1
		cp		W0,	W1
		bra		Z,	U1TXInterrupt_NoData	; branch if Head=Tail (no data)      
;
;        btsc 	U1STA,	#UTXBF         	; skip next transmitter has room   
;		goto	U1TXInterrupt_Exit		; else load more into transmit buffer
;
        bclr 	IFS0,	#U1TXIF         ; Clear the U1TX Interrupt flag bit. 
		mov.b	[W1],	W0
		mov.b	WREG,	U1TXREG
		inc		W1,	W1
		mov		#U1TXBuffer+UARTBuffer_Length,	W0
		cp		W0,	W1
		bra		NZ,	U1TXInterrupt_NoWrap
;
		mov		#U1TXBuffer,	W1        
;
U1TXInterrupt_NoWrap:
		mov		W1,	U1TXBuffer_Tail
        btss 	U1STA,	#UTXBF         ; skip next transmitter is full   
;		goto	U1TXInterrupt_Loop		; else load more into transmit buffer
;
		goto	U1TXInterrupt_Exit		; leave cause transmit buffer is full	
;
U1TXInterrupt_NoData:
		bclr	IEC0,	#U1TXIF         ; Prevent further U1TX interrupts
		goto  	U1TXInterrupt_Exit
;
U1TXInterrupt_Exit:        
		pop.D 	W0                   	;Retrieve context POP-ping from Stack
        retfie                     		;Return from Interrupt Service routine
;
;***************************************;***************************************
;
;	UART1 RX Interrupt Service Routine
;
;***************************************;***************************************
;
__U1RXInterrupt:
        push.D 	W0                  	; Save context using double-word PUSH
        push.D 	W2                  	; Save context using double-word PUSH        
        bclr 	IFS0,	#U1RXIF         ; Clear the U1RX Interrupt flag bit.
;                
		btsc	U1STA,	#OERR			; skip next if no OERR
		goto	U1RXInterrupt_OERR
;		
		btsc	U1STA,	#FERR			; skip next if no FERR
		goto	U1RXInterrupt_FERR		
;		
		btsc	U1STA,	#PERR			; skip next if no PERR
		goto	U1RXInterrupt_PERR	
;
		mov		U1RXBuffer_Head,	WREG
		inc		W0,	W1
		mov		W0,	W2
		mov		#U1RXBuffer+UARTBuffer_Length,	W0
		cp		W0,	W1
		bra		NZ,	U1RXInterrupt_NoWrap
;
		mov		#U1RXBuffer,	W1
;
U1RXInterrupt_NoWrap:				
		mov		U1RXBuffer_Tail,	W0
		cp		W0,	W1		
		bra		Z,	U1RXInterrupt_NoRoom
;
		mov.b	U1RXREG,	WREG
		mov.b	W0,	[W2]
		mov		W1,	U1RXBuffer_Head		
;
		goto	U1RXInterrupt_Exit	
;				
U1RXInterrupt_OERR:
		bclr	U1STA,	#OERR
		goto	U1RXInterrupt_Exit
;		
U1RXInterrupt_FERR:
		mov.b	U1RXREG,	WREG		; dummy read to toss out bad data
		goto	U1RXInterrupt_Exit
;		
U1RXInterrupt_PERR:	
		mov.b	U1RXREG,	WREG		; dummy read to toss out bad data	
		goto	U1RXInterrupt_Exit
;
U1RXInterrupt_NoRoom:
		mov.b	U1RXREG,	WREG		; toss out data, no room in U1RXBuffer
		goto	U1RXInterrupt_Exit
;
U1RXInterrupt_Exit:
        pop.D 	W2                   	; Retrieve context POP-ping from Stack
        pop.D 	W0                   	; Retrieve context POP-ping from Stack        
        retfie                     		; Return from Interrupt Service routine
;
;***************************************;***************************************
;
;	UART2 TX Interrupt Service Routine
;
;***************************************;***************************************
;
__U2TXInterrupt:
        push.d 	W0 						; Save context using double-word PUSH
;        bclr 	IFS1,	#U2TXIF         ; Clear the U2TX Interrupt flag bit       
;
U2TXInterrupt_Loop:                         	
		mov		U2TXBuffer_Head,	W0
		mov		U2TXBuffer_Tail,	W1
		cp		W0,	W1
		bra		Z,	U2TXInterrupt_NoData	; branch if Head=Tail (no data)      
;
;        btsc 	U2STA,	#UTXBF         	; skip next transmitter has room   
;		goto	U2TXInterrupt_Exit		; else load more into transmit buffer
;
        bclr 	IFS1,	#U2TXIF         ; Clear the U2TX Interrupt flag bit 		
		mov.b	[W1],	W0
		mov.b	WREG,	U2TXREG 
		inc		W1,	W1
		mov		#U2TXBuffer+UARTBuffer_Length,	W0
		cp		W0,	W1
		bra		NZ,	U2TXInterrupt_NoWrap
;
		mov		#U2TXBuffer,	W1        
;
U2TXInterrupt_NoWrap:
		mov		W1,	U2TXBuffer_Tail       
;		goto	U2TXInterrupt_Loop		; else load more into transmit buffer
		goto	U2TXInterrupt_Exit
;
U2TXInterrupt_NoData:
		bclr	IEC1,	#U2TXIF         ; Prevent further U2TX interrupts
		goto  	U2TXInterrupt_Exit
;
U2TXInterrupt_Exit:       
		pop.d 	W0                   	;Retrieve context POP-ping from Stack
        retfie                     		;Return from Interrupt Service routine
;
;***************************************;***************************************
;
;	UART2 RX Interrupt Service Routine
;
;***************************************;***************************************
;
__U2RXInterrupt:
        push.D 	W0                  	; Save context using double-word PUSH
        push.D 	W2                  	; Save context using double-word PUSH        
        bclr 	IFS1,	#U2RXIF         ; Clear the U2RX Interrupt flag bit.
;                
		btsc	U2STA,	#OERR			; skip next if no OERR
		goto	U2RXInterrupt_OERR
;		
		btsc	U2STA,	#FERR			; skip next if no FERR
		goto	U2RXInterrupt_FERR		
;		
		btsc	U2STA,	#PERR			; skip next if no PERR
		goto	U2RXInterrupt_PERR	
;
		mov		U2RXBuffer_Head,	WREG
		inc		W0,	W1
		mov		W0,	W2
		mov		#U2RXBuffer+UARTBuffer_Length,	W0
		cp		W0,	W1		
		bra		NZ,	U2RXInterrupt_NoWrap
;
		mov		#U2RXBuffer,	W1
;
U2RXInterrupt_NoWrap:				
		mov		U2RXBuffer_Tail,	W0
		cp		W0,	W1		
		bra		Z,	U2RXInterrupt_NoRoom
;
		mov.b	U2RXREG,	WREG
		mov.b	W0,	[W2]
		mov		W1,	U2RXBuffer_Head		
;
		goto	U2RXInterrupt_Exit	
;				
U2RXInterrupt_OERR:
		bclr	U2STA,	#OERR
		goto	U2RXInterrupt_Exit
;		
U2RXInterrupt_FERR:
		mov.b	U2RXREG,	WREG		; dummy read to toss out bad data
		goto	U2RXInterrupt_Exit
;		
U2RXInterrupt_PERR:	
		mov.b	U2RXREG,	WREG		; dummy read to toss out bad data	
		goto	U2RXInterrupt_Exit
;
U2RXInterrupt_NoRoom:
		mov.b	U2RXREG,	WREG		; toss out data, no room in U2RXBuffer
		goto	U2RXInterrupt_Exit
;
U2RXInterrupt_Exit:
        pop.D 	W2                   	; Retrieve context POP-ping from Stack 
        pop.D 	W0                   	; Retrieve context POP-ping from Stack        
        retfie                     		; Return from Interrupt Service routine 
;
;***************************************;***************************************
;
;	Timer2 Interrupt Service Routine
;
;***************************************;***************************************
;
__T2Interrupt:
        push.d 	W0                  	; Save context using double-word PUSH        
        bclr 	IFS0,	#T2IF         	; Clear the U2RX Interrupt flag bit.
        bset	Flags,	#ActiveSenseMessage	; Set Flag to send message
;
T2Interrupt_Exit:
		pop.d	W0        		  
		retfie 
;
;***************************************;***************************************
;
;	Timer4 Interrupt Service Routine
;
;***************************************;***************************************
;
__T4Interrupt:
        push.d 	W0                  	; Save context using double-word PUSH        
        bclr 	IFS1,	#T4IF         	; Clear the U2RX Interrupt flag bit.
        bset	Flags,	#MidiClockMessage	; Set Flag to send message        
;
T4Interrupt_Exit:
		clr		TMR2					; clear Active Sense Message
		pop.d	W0        		  
		retfie 		     
;
;***************************************;***************************************
;
;	Tables
;
;***************************************;***************************************
;         
SignOn1:
		.asciz	"ftb274 - Midi"
SignOn2:		
		.asciz	"jeff bachiochi"
SignOn3:
		.asciz	"www.imaginethatnow.com"
Message:
		.asciz	"Message:"		
Message8:
		.asciz	"Note Off ("
Message9:
		.asciz	"Note On ("
MessageA:
		.asciz	"AfterTouch ("
MessageB:
		.asciz	"Control Change ("
MessageC:
		.asciz	"Program Change ("
MessageD:
		.asciz	"Channel Pressure ("												
MessageE:
		.asciz	"Pitch Wheel ("		
MessageF0:
		.asciz	"Start of SysEx ("	
MessageF1:
		.asciz	"MTC Quarter Frame, "
TimeCode:
		.asciz	"TimeCode:"		
MessageF2:
		.asciz	"Song Position Pointer, "
MidiBeat:
		.asciz	"MidiBeat:"			
MessageF3:
		.asciz	"Song Select, "
Song:
		.asciz	"Song:"	
MessageF6:
		.asciz	"Tune Request"	
MessageF7:
		.asciz	") End of SysEx"
MessageF8:
		.asciz	"Midi Clock"	
MessageF9:
		.asciz	"Tick"
MessageFA:
		.asciz	"Midi Start"
MessageFB:
		.asciz	"Midi Continue"	
MessageFC:
		.asciz	"Midi Stop"	
MessageFE:
		.asciz	"Active Sense"	
MessageFF:
		.asciz	"Reset"										
Channel:
		.asciz	"Channel:"
Note:
		.asciz	"Note:"
Velocity:
		.asciz	"Velocity:"	
Pressure:
		.asciz	"Pressure:"
Controller:
		.asciz	"Controller:"
Value:
		.asciz	"Value:"
Program:
		.asciz	"Program:"
Transpose:
		.asciz	"Transpose:"
Pad:
		.asciz	"Pad:"
Voice:																					                    
		.asciz	"Voice:"
Beats:																					                    
		.asciz	"BPM (tempo):"		
EntryError:
		.asciz 	"Entry Error"
Triggering:
		.asciz 	"Triggering Pad:"				
;
;***************************************;***************************************
;
;	End
;
;***************************************;***************************************
;

.end                               ;End of program code in this file



